<?php
/**
 * @version		$Id: GuestBook.php 10554 2008-07-15 17:15:19Z ircmaxell $
 * @package		Joomla
 * @subpackage	GuestBook
 * @copyright	Copyright (C) 2005 - 2008 Open Source Matters. All rights reserved.
 * @license		GNU/GPL, see LICENSE.php
 * Joomla! is free software. This version may have been modified pursuant
 * to the GNU General Public License, and as distributed it includes or
 * is derivative of works licensed under the GNU General Public License or
 * other free or open source software licenses.
 * See COPYRIGHT.php for copyright notices and details.
 */

// no direct access
defined( '_JEXEC' ) or die( 'Restricted access' );

/**
* @package		Joomla
* @subpackage	GuestBook
*/
class GuestBookViewguestbook
{
	function setCommentToolbar()
	{
		JToolBarHelper::title( JText::_( 'Guest Book Manager' ), 'generic.png' );
		JToolBarHelper::publishList();
		JToolBarHelper::unpublishList();
		JToolBarHelper::editListX();
		JToolBarHelper::deleteList();
		JToolBarHelper::preferences('com_guestbook', '200');
	}

	function GuestBook( &$rows, &$pageNav, &$lists )
	{
		GuestBookViewguestbook::setCommentToolbar();
		$user =& JFactory::getUser();
		JHTML::_('behavior.tooltip');
		?>
		<form action="index.php?option=com_guestbook" method="post" name="adminForm">
		<table>
		<tr>
			<td align="left" width="100%">
				<?php echo JText::_( 'Filter' ); ?>:
				<input type="text" name="search" id="search" value="<?php echo $lists['search'];?>" class="text_area" onchange="document.adminForm.submit();" />
				<button onclick="this.form.submit();"><?php echo JText::_( 'Go' ); ?></button>
				<button onclick="document.getElementById('search').value='';this.form.getElementById('filter_state').value='';this.form.submit();"><?php echo JText::_( 'Filter Reset' ); ?></button>
			</td>
			<td nowrap="nowrap">
				<?php
 					echo $lists['state'];
				?>
			</td>
		</tr>
		</table>

			<table class="adminlist">
			<thead>
				<tr>
					<th width="20">
						<?php echo JText::_( 'Num' ); ?>
					</th>
					<th width="20">
						<input type="checkbox" name="toggle" value=""  onclick="checkAll(<?php echo count( $rows ); ?>);" />
					</th>
					<th width="10%" nowrap="nowrap">
						<?php echo JHTML::_('grid.sort',   'Name', 'b.postedby', @$lists['order_Dir'], @$lists['order'] ); ?>
					</th>
					<th width="10%" nowrap="nowrap">
						<?php echo JHTML::_('grid.sort',   'e-Mail', 'b.post_email', @$lists['order_Dir'], @$lists['order'] ); ?>
					</th>
					<th nowrap="nowrap" class="title">
						<?php echo JHTML::_('grid.sort',  'Title', 'b.post_title', @$lists['order_Dir'], @$lists['order'] ); ?>
					</th>
					<th width="10%" nowrap="nowrap">
						<?php echo JHTML::_('grid.sort',   'Posted On', 'b.post_date', @$lists['order_Dir'], @$lists['order'] ); ?>
					</th>
					<th width="10%" nowrap="nowrap">
						<?php echo JHTML::_('grid.sort',   'Updated On', 'b.post_update', @$lists['order_Dir'], @$lists['order'] ); ?>
					</th>
					<th width="5%" nowrap="nowrap">
						<?php echo JHTML::_('grid.sort',  'Published', 'b.published', @$lists['order_Dir'], @$lists['order'] ); ?>
					</th>
				</tr>
			</thead>
			<tfoot>
				<tr>
					<td colspan="13">
						<?php echo $pageNav->getListFooter(); ?>
					</td>
				</tr>
			</tfoot>
			<tbody>
			<?php
			$k = 0;
			for ($i=0, $n=count( $rows ); $i < $n; $i++) {
				$row = &$rows[$i];

				$row->id	= $row->id;
				$link		= JRoute::_( 'index.php?option=com_guestbook&task=edit&cid[]='. $row->id );
 				
 				$row->published = $row->published;
				$published 		= JHTML::_('grid.published', $row, $i );
				$checked		= JHTML::_('grid.checkedout',   $row, $i );
				?>
				<tr class="<?php echo "row$k"; ?>">
					<td align="center">
						<?php echo $pageNav->getRowOffset($i); ?>
					</td>
					<td align="center">
						<?php echo $checked; ?>
					</td>
 					<td>
					<span class="editlinktip hasTip" title="<?php echo JText::_( 'Edit' );?>::<?php echo JText::_($row->postedby); ?>...">
						<?php
						if ( JTable::isCheckedOut($user->get ('id'), $row->checked_out ) ) {
							echo $row->postedby;
						} else {
							?>

							<a href="<?php echo $link; ?>">
								<?php echo $row->postedby; ?></a>
							<?php
						}
						?>
						</span>
					</td>
					<td align="center"><?php echo $row->post_email;?></td>
					<td>
					<span class="editlinktip hasTip" title="<?php echo JText::_( 'Edit' );?>::<?php echo substr(JText::_($row->post_title),0, 200); ?>...">
						<?php
						if ( JTable::isCheckedOut($user->get ('id'), $row->checked_out ) ) {
							echo $row->post_title;
						} else {
							?>

							<a href="<?php echo $link; ?>">
								<?php echo $row->post_title; ?></a>
							<?php
						}
						?>
						</span>
					</td>
					<td align="center">
						<?php echo JHTML::_('date',  $row->post_date, JText::_('DATE_FORMAT_LC1')); ?>
					</td>
					<td align="center">
						<?php echo JHTML::_('date',  $row->post_update, JText::_('DATE_FORMAT_LC1')); ?>
					</td>
					<td align="center">
						<?php echo $published;?>
					</td>
				</tr>
				<?php
				$k = 1 - $k;
			}
			?>
			</tbody>
			</table>

		<input type="hidden" name="c" value="guestbook" />
		<input type="hidden" name="option" value="com_guestbook" />
		<input type="hidden" name="task" value="" />
		<input type="hidden" name="boxchecked" value="0" />
		<input type="hidden" name="filter_order" value="<?php echo $lists['order']; ?>" />
		<input type="hidden" name="filter_order_Dir" value="<?php echo $lists['order_Dir']; ?>" />
		<?php echo JHTML::_( 'form.token' ); ?>
		</form>
		<?php
	}

	function setCommentPostToolbar()
	{
		$task = JRequest::getVar( 'task', '', 'method', 'string');

		JToolBarHelper::title( $task == 'add' ? JText::_( 'Guest Book' ) . ': <small><small>[ '. JText::_( 'New' ) .' ]</small></small>' : JText::_( 'Guest Book Comment' ) . ': <small><small>[ '. JText::_( 'Edit' ) .' ]</small></small>', 'generic.png' );
		JToolBarHelper::save( 'save' );
		JToolBarHelper::apply('apply');
		JToolBarHelper::cancel( 'cancel' );
	}
	
	/**
	 *function for Edit Posts
	 **/
	function editCommentpost( &$row, &$lists )
	{
		GuestBookViewguestbook::setCommentPostToolbar();
		JRequest::setVar( 'hidemainmenu', 1 );
		JFilterOutput::objectHTMLSafe( $row, ENT_QUOTES, 'custombannercode' );
		$editor =& JFactory::getEditor();
		$Edoptions['theme']	= 'simple';
		?>
		<script language="javascript" type="text/javascript">
		<!--
		function submitbutton(pressbutton) {
			var form = document.adminForm;
			if (pressbutton == 'cancel') {
				submitform( pressbutton );
				return;
			}
			// do field validation
			if (form.postedby.value == "") {
				alert( "<?php echo JText::_( 'You must provide name.', true ); ?>" );
			} else if (form.post_email.value == "") {
				alert( "<?php echo JText::_( 'You must provide e-Mail.', true ); ?>" );
			} else if (form.post_title.value == "") {
				alert( "<?php echo JText::_( 'You must provide title.', true ); ?>" );
			}else{
				submitform( pressbutton );
			}
		}
 		//-->
		</script>
		<form action="index.php" method="post" name="adminForm">
		<div class="col100">
			<fieldset class="adminform">
				<legend><?php echo JText::_( 'Details' ); ?></legend>
				<table width="63%" class="admintable">
				<tbody>
					<tr>
						<td height="25" valign="top"><label id="postedbymsg" for="postedby"><?php echo JText::_( 'Posted By' ); ?>:</label></td>
						<td valign="top"><div id="clsTableTdPadd"><input type="text" maxlength="150" size="70%"  class="inputbox required" name="postedby" id="postedby" value="<?php echo $row->postedby;?>" /> *</div></td>
					</tr>
					<tr>
						<td height="25" valign="top"><label id="post_emailmsg" for="post_email"><?php echo JText::_( 'e-Mail' ); ?>:</label></td>
						<td valign="top"><div id="clsTableTdPadd"><input type="text" maxlength="150" size="70%"  class="inputbox required" name="post_email" id="post_email" value="<?php echo $row->post_email;?>" /> *</div></td>
					</tr>
					<tr>
						<td height="25" valign="top"><label id="post_urlmsg" for="post_url"><?php echo JText::_( 'URL' ); ?>:</label></td>
						<td valign="top"><div id="clsTableTdPadd"><input type="text" maxlength="150" size="70%"  class="inputbox required" name="post_url" id="post_url" value="<?php echo $row->post_url;?>" /></div></td>
					</tr>
					<tr>
						<td height="25" valign="top"><label id="post_titlemsg" for="post_title"><?php echo JText::_( 'Title' ); ?>:</label></td>
						<td valign="top"><div id="clsTableTdPadd"><input type="text" maxlength="150" size="70%"  class="inputbox required" name="post_title" id="post_title" value="<?php echo $row->post_title;?>" /> *</div></td>
					</tr>
					<tr>
						<td width="19%" height="25" valign="top"><label id="post_descmsg" for="post_desc"><?php echo JText::_( 'Description' ); ?>:</label></td>
						<td width="81%" valign="top">
						<div id="clsTableTdPadd">
							<div>
							<?php
								echo $editor->display('post_desc', $row->post_desc, '95%', '150', '50', '6', false, $Edoptions);
							?>
							</div>
						</div>
						</td>
					</tr>
					<tr>
						<td height="25" valign="top"><?php echo JText::_( 'Upload Image' ); ?></td>
						<td valign="top">
						<div id="clsTableTdPadd">
							<input type="hidden" name="image_old" id="image_old" value="<?php echo $row->post_image;?>" />
							<div>
							<?php if($row->post_image){?>
							<div align="left">
								<img src="../components/com_guestbook/Images/<?php echo "th".$row->post_image;?>"  border="0" alt="Image"  class="clsImgPad" />
							</div>
							<?php } ?>
							</div>
 						</div>
						</td>
					</tr>
					<tr>
						<td height="25" valign="top" colspan="2" class="clsTDBorderTop"><label id="product_specialmsg" for="product_special"><?php echo JText::_( 'Do you want to publish?' ); ?>:</label>
						<?php print $lists['published'] = JHTML::_('select.booleanlist', 'published', 'class="inputbox"  size="1"', ( isset($row->published)) ? $row->published : 1); ?>
						</td>
					</tr>
					<tr>
						<td colspan="2" height="25" align="right" class="clsTDBorderTop">
							<?php echo JText::_( '* Required' ); ?>
						</td>
					</tr>
  				</tbody>
			</table>
			</fieldset>
		</div>
		<div class="clr"></div>

		<input type="hidden" name="c" value="guestbook" />
		<input type="hidden" name="option" value="com_guestbook" />
		<input type="hidden" name="id" value="<?php echo $row->id; ?>" />
		<input type="hidden" name="task" value="" />
		<?php echo JHTML::_( 'form.token' ); ?>
		</form>
		<?php
	}
}
?>