<?php
/**
 * Hello Model for Hello World Component
 * 
 * @package    Joomla
 * @subpackage Components
 * @license    GNU/GPL
 */

// No direct access
defined( '_JEXEC' ) or die( 'Restricted access' );

jimport( 'joomla.application.component.model' );

/**
 * Hello Model
 *
 * @package    Joomla
 * @subpackage Components
 */
class GuestBookModelGuestBook extends JModel
{
	/**
	 * Constructor that retrieves the ID from the request
	 *
	 * @access	public
	 * @return	void
	 */
	function __construct()
	{
		parent::__construct();
	}
	
	/**
	 * Gets the Company Profile
	 * @return string The greeting to be displayed to the user
	 */
	function fncGetCommentList()
	{
		global $mainframe, $option;
		
		$config = JFactory::getConfig();
		// Get the pagination request variables
 		
		$this->setState('limit', $mainframe->getUserStateFromRequest('com_guestbook.limit', 'limit', $config->getValue('config.list_limit'), 'int'));
		$this->setState('limitstart', JRequest::getVar('limitstart', 0, '', 'int'));
 
		// In case limit has been changed, adjust limitstart accordingly
		$this->setState('limitstart', ($this->getState('limit') != 0 ? (floor($this->getState('limitstart') / $this->getState('limit')) * $this->getState('limit')) : 0));

		$db		=& JFactory::getDBO();				
		$query	= "SELECT post.*
				FROM #__guestbook_postings AS post
				WHERE published = '1' ORDER BY post_date DESC";
		$commentlist = $this->_getList( $query, $this->getState('limitstart'), $this->getState('limit'));
		return @$commentlist;
	}
	
	// function for getTotal
	function getTotal()
	{
		$query = "SELECT * FROM #__guestbook_postings WHERE published = '1' ORDER BY post_date DESC LIMIT 0, 100";
		$commentlist = $this->_getList( $query);
		$this->_total = count($commentlist);
		return $this->_total;
	}
	
	// Get pagination
	function getPagination()
    {
      // Lets load the content if it doesn't already exist
      if (empty($this->_pagination))
      {
         jimport('joomla.html.pagination');
         $this->_pagination = new JPagination( $this->getTotal(), $this->getState('limitstart'), $this->getState('limit') );
    }
      return $this->_pagination;
   }
}
?>