<?php
/**
* Core file
* @author Vince Wooll <sales@jomres.net>
* @version Jomres 6
* @package Jomres
* @copyright	2005-2012 Vince Wooll
* Jomres (tm) PHP files are released under both MIT and GPL2 licenses. This means that you can choose the license that best suits your project, and use it accordingly, however all images, css and javascript which are copyright Vince Wooll are not GPL licensed and are not freely distributable. 
**/


// ################################################################
defined( '_JOMRES_INITCHECK' ) or die( '' );
// ################################################################

class jomres_editing_mode
	{
	/**
	#
	 * Constructor for the jomres_booking object, sets a bunch of variables, finds configuration settings & gets the current state of the booking from the tmpbooking table
	#
	 */
	function jomres_editing_mode()
		{
		$tmpBookingHandler =jomres_singleton_abstract::getInstance('jomres_temp_booking_handler');
		// We'll specifically set the post and get routines here so that we don't end up saving the cookie/cms specific code every time if the cookie's the container for the lang.
		$thisJRUser=jomres_singleton_abstract::getInstance('jr_user');
		$siteConfig = jomres_singleton_abstract::getInstance('jomres_config_site_singleton');
		$jrConfig=$siteConfig->get();
		$this->editing_allowed = true;
		if (!isset($tmpBookingHandler->user_settings['editing_on']))
			{
			$tmpBookingHandler->user_settings['editing_on']= false;
			}
		if (!$thisJRUser->userIsManager)
			{
			$this->editing_allowed = false;
			$tmpBookingHandler->user_settings['editing_on']= false;
			}
		if ($thisJRUser->userIsManager && $thisJRUser->accesslevel < 2)
			{
			$this->editing_allowed = false;
			$tmpBookingHandler->user_settings['editing_on']= false;
			}
		if ($jrConfig['minimalconfiguration'] == '1' && !$thisJRUser->superPropertyManager)
			{
			$this->editing_allowed = false;
			$tmpBookingHandler->user_settings['editing_on']= false;
			}
		$this->editing = $tmpBookingHandler->user_settings['editing_on'];
		$tmpBookingHandler->close_jomres_session();
		}
		
	function switch_mode_on()
		{
		if (!$this->editing_allowed)
			return false;
		$tmpBookingHandler =jomres_singleton_abstract::getInstance('jomres_temp_booking_handler');
		$tmpBookingHandler->user_settings['editing_on']= true;
		$tmpBookingHandler->close_jomres_session();
		}
		
	function switch_mode_off()
		{
		if (!$this->editing_allowed)
			return false;
		$tmpBookingHandler =jomres_singleton_abstract::getInstance('jomres_temp_booking_handler');
		$tmpBookingHandler->user_settings['editing_on']= false;
		$tmpBookingHandler->close_jomres_session();
		}
		
	function make_editing_mode_dropdown()
		{
		if (!$this->editing_allowed)
			return false;
		$on_text = jr_gettext('_JOMRES_EDITINGMODE_ON',_JOMRES_EDITINGMODE_ON,false);
		$off_text = jr_gettext('_JOMRES_EDITINGMODE_OFF',_JOMRES_EDITINGMODE_OFF,false);
		
		$mode_options = array();
		$mode_options[] = jomresHTML::makeOption( '0' ,  $off_text);
		$mode_options[] = jomresHTML::makeOption( '1' , $on_text );
		$javascript = 'onchange="switch_editing_mode(\''.JOMRES_SITEPAGE_URL_RAW.'\',this.value);"';
		return jomresHTML::selectList( $mode_options, 'jomres_editing_mode',' AUTOCOMPLETE="OFF" class="inputbox" size="1" '.$javascript.'', 'value', 'text', $this->editing);
		}
	
	}


?>