<?php
/**
 * @author Darang
 * @copyright 2009 JExt
 */
defined ( '_JEXEC' ) or die ( 'Restricted access' );

class weather_data_weather_co_ua extends weather_data {
	
	//url xml файла с данными
	public $url = 'http://xml.weather.co.ua/1.2/forecast/';
	
	public $date_format = "m/d/Y";
	
	function get_array($xml) {
		
		$operation_array = array ();
		
		if (! isset ( $xml->document->forecast )) {
			$operation_array ['error'] = "Не возможно получить данные";
			return $operation_array;
		}
		
		//$dates = $xml->document->forecast->city->attributes ( "date" );
		

		if (isset ( $xml->document->current )) {
			try {
			$current_conditions = $xml->document->current;
			if($current_conditions [0]->time){
			$operation_array ['current'] ['time'] = $current_conditions [0]->time [0]->data ();
			$operation_array ['current'] ['cloud'] = $current_conditions [0]->cloud [0]->data ();
			$operation_array ['current'] ['pict'] = $current_conditions [0]->pict [0]->data ();
			$operation_array ['current'] ['t'] = $current_conditions [0]->t [0]->data ();
			$operation_array ['current'] ['t_flik'] = $current_conditions [0]->t_flik [0]->data ();
			$operation_array ['current'] ['p'] = $current_conditions [0]->p [0]->data ();
			$operation_array ['current'] ['w'] = $current_conditions [0]->w [0]->data ();
			$operation_array ['current'] ['w_gust'] = $current_conditions [0]->w_gust [0]->data ();
			$operation_array ['current'] ['w_rumb'] = $current_conditions [0]->w_rumb [0]->data ();
			$operation_array ['current'] ['h'] = $current_conditions [0]->h [0]->data ();
			}else{
				$operation_array ['current'] ['error'] = CURRENT_WEATHER_DATA_ERROR;
			}
			} catch (Exception $e) {
				$operation_array ['current'] ['error'] = $e->getMessage();
			}
		} else {
			$operation_array ['current'] ['error'] = CURRENT_WEATHER_ERROR;
		}
		
		if (isset ( $xml->document->city )) {
			$city_conditions = $xml->document->city;
			$operation_array ['city'] ['name'] = $city_conditions [0]->name [0]->data ();
			$operation_array ['city'] ['name_en'] = $city_conditions [0]->name_en [0]->data ();
			if ($city_conditions [0]->region [0]->name [0]) {
				$operation_array ['city'] ['region'] = $city_conditions [0]->region [0]->name [0]->data ();
				$operation_array ['city'] ['region_en'] = $city_conditions [0]->region [0]->name_en [0]->data ();
			}
			$operation_array ['city'] ['country'] = $city_conditions [0]->country [0]->name [0]->data ();
			$operation_array ['city'] ['country_en'] = $city_conditions [0]->country [0]->name_en [0]->data ();
		
		}
		
		$forecast = $xml->document->forecast [0]->day;
		
		for($i = 0; $i < count ( $forecast ); $i ++) {
			$data = $forecast [$i];
			
			//NumCode – цифровой код
			$operation_array ['forecast'] [$i] ['date'] = $data->attributes ( "date" );
			$operation_array ['forecast'] [$i] ['hour'] = $data->attributes ( "hour" );
			$operation_array ['forecast'] [$i] ['cloud'] = $data->cloud [0]->data ();
			$operation_array ['forecast'] [$i] ['pict'] = $data->pict [0]->data ();
			//CharCode – буквенный код
			$operation_array ['forecast'] [$i] ['ppcp'] = $data->ppcp [0]->data ();
			//Scale – номинал
			$operation_array ['forecast'] [$i] ['t'] ['min'] = $data->t [0]->min [0]->data ();
			$operation_array ['forecast'] [$i] ['t'] ['max'] = $data->t [0]->max [0]->data ();
			
			$operation_array ['forecast'] [$i] ['p'] ['min'] = $data->p [0]->min [0]->data ();
			$operation_array ['forecast'] [$i] ['p'] ['max'] = $data->p [0]->max [0]->data ();
			
			$operation_array ['forecast'] [$i] ['wind'] ['min'] = $data->wind [0]->min [0]->data ();
			$operation_array ['forecast'] [$i] ['wind'] ['max'] = $data->wind [0]->max [0]->data ();
			$operation_array ['forecast'] [$i] ['wind'] ['rumb'] = $data->wind [0]->rumb [0]->data ();
			
			$operation_array ['forecast'] [$i] ['hmid'] ['min'] = $data->hmid [0]->min [0]->data ();
			$operation_array ['forecast'] [$i] ['hmid'] ['max'] = $data->hmid [0]->max [0]->data ();
			//Name – наименование валюты
			$operation_array ['forecast'] [$i] ['wpi'] = $data->wpi [0]->data ();
		
		}
		
		//$operation_array ['info'] = array ("bank_name" => $this->bank_name, "currency_name" => $this->currency_name );
		

		return $operation_array;
	
	}
	
	/**
	 * Возвращает url адрес для получения xml
	 * @param string $url
	 */
	public function getUrl($city_id, $dayf = "", $site_id = "", $lang = "ru") {
		return $this->url . $city_id . "?dayf=" . $dayf . "&lang=" . $lang . "&userid=" . $site_id;
	}

}
?>