<?php

class Util {
	
	/**
	 * return the day period 
	 * @param int $hour
	 */
	static function GetDayPeriod($hour) {
		$getday = array (3 => "night", 9 => "morn", 15 => "day", 21 => "even" );
		return $getday [$hour];
	}
	
	/**
	 * return the cloudiness
	 * @param string $img
	 */
	static function GetCloudiness($img) {
		$cloudiness = array ('_0_moon.gif' => "SUNSHINE", '_0_sun.gif' => "SUNSHINE", '_1_moon_cl.gif' => "SUN_CLOUDY", '_1_sun_cl.gif' => "SUN_CLOUDY", '_2_cloudy.gif' => "CLOUDY", '_3_pasmurno.gif' => "MORE_CLOUDY", '_4_short_rain.gif' => "SHORT_RAIN", '_5_rain.gif' => "RAIN", '_6_lightning.gif' => "LIGHTING", '_7_hail.gif' => "HAIL", '_8_rain_swon.gif' => "RAIN_SNOW", '_9_snow.gif' => "SNOW", '_10_heavy_snow.gif' => "HEAVY_SNOW", '_255_NA.gif' => "NA" );
		return $cloudiness [$img];
	}
	
	/**
	 * return the count of period for this day
	 * @param int $hour
	 */
	static function GetCountPeriod($hour) {
		$period = array (3 => 1, 9 => 4, 15 => 3, 21 => 2 );
		return $period [$hour];
	}
	
	/**
	 * Return the wind direction
	 * @param int $winds
	 */
	static function GetWindDirection($winds) {
		if ($winds <= 20)
			return "N";
		elseif ($winds <= 35)
			return "NNE";
		elseif ($winds <= 55)
			return "NE";
		elseif ($winds <= 70)
			return "ENE";
		elseif ($winds <= 110)
			return "E";
		elseif ($winds <= 125)
			return "ESE";
		elseif ($winds <= 145)
			return "SE";
		elseif ($winds <= 160)
			return "SSE";
		elseif ($winds <= 200)
			return "S";
		elseif ($winds <= 215)
			return "SSW";
		elseif ($winds <= 235)
			return "SW";
		elseif ($winds <= 250)
			return "WSW";
		elseif ($winds <= 290)
			return "W";
		elseif ($winds <= 305)
			return "WNW";
		elseif ($winds <= 325)
			return "NW";
		elseif ($winds <= 340)
			return "NNW";
		elseif ($winds <= 360)
			return "N";
		else
			return "n/a";
	}
	
}

?>