<?php
/*------------------------------------------------------------------------
# mod_sp_weather - Weather Module by JoomShaper.com
# ------------------------------------------------------------------------
# author    JoomShaper http://www.joomshaper.com
# copyright Copyright (C) 2010 JoomShaper.com. All Rights Reserved.
# @license - http://www.gnu.org/licenses/gpl-2.0.html GNU/GPL
# Websites: http://www.joomshaper.com - http://www.joomxpert.com
-------------------------------------------------------------------------*/

// no direct access
defined( '_JEXEC' ) or die( 'Restricted access' );
$layout			= $params->get('layout','block');
$fcast 			= $params->get('forecast','4');
$city 			= $params->get('city',1);
$condition 		= $params->get('condition',1);
$humidity 		= $params->get('humidity',1);
$wind 			= $params->get('wind',1);
$tempUnit 		= $params->get('tempUnit','c');
$separator 		= $params->get('separator','/');
?>
<div id="weather_sp1_id<?php echo $uniqid; ?>" class="weather_sp1">
	
	<?php if (isset($weather->error)) { ?>
		<div class="spw_row error"><?php echo $weather->error; ?></div>    
	<?php } else { ?>
		<div class="weather_sp1_c">
			<div class="weather_sp1_cleft">
				<img class="spw_icon_big" src="<?php echo $weather->c_icon; ?>" title="<?php echo $weather->c_condition; ?>" alt="<?php echo $weather->c_condition; ?>" />
				<br style="clear:both" />
				<p class="spw_current_temp">
				<?php if ($tempUnit=='f') { ?>
					<?php echo $weather->c_temp_f; ?>&deg;F			
				<?php } else { ?>
					<?php echo $weather->c_temp_c; ?>&deg;C		
				<?php } ?>
				</p>
			
			</div>
			<div class="weather_sp1_cright">
				<?php if($city==1) { ?>
					<h2 class="weather_sp1_city"><?php echo $params->get('location','London,UK') ?></h2> 
				<?php } ?>
				
				<?php if($condition==1) { ?>
				<div class="spw_row"><?php echo $weather->c_condition; ?></div>
				<?php } ?>
				
				<?php if($humidity==1) { ?>
				<div class="spw_row"><?php echo $weather->c_humidity; ?></div>
				<?php } ?>
				
				<?php if($wind==1) { ?>
				<div class="spw_row"><?php echo $weather->c_wind; ?></div>
				<?php } ?>
			</div>
			<div style="clear:both"></div>		
		</div>
		<div style="clear:both"></div>
		<?php if ($fcast!='disabled') { ?>
			<div class="weather_sp1_main">
				<?php for($i = 0; $i < $fcast; $i++) : ?>
					<?php if ($layout=='list') { ?>
						<div class="list_<?php echo ($i%2 ? 'even' : 'odd') ?>">
							<span class="weather_sp1_list_day"><?php echo $weather->forecast[$i]['day_of_week']; ?></span>
							<span class="weather_sp1_list_temp"><?php echo modSPWeatherHelper::convert($weather->forecast[$i]['low'],$weather->unit,$tempUnit) . '&nbsp;' . $separator . '&nbsp;' . modSPWeatherHelper::convert($weather->forecast[$i]['high'],$weather->unit,$tempUnit); ?></span>
							<span class="weather_sp1_list_icon"><img class="spw_icon" src="<?php echo $weather->forecast[$i]['icon']; ?>" align="right" title="<?php echo $weather->forecast[$i]['condition']; ?>" alt="<?php echo $weather->forecast[$i]['condition']; ?>" /></span>
							<div style="clear:both"></div>
						</div>				
					<?php } else { ?> 
						<div class="block_<?php echo ($i%2 ? 'even' : 'odd') ?>" style="float:left;width:<?php echo round(100/$fcast) ?>%">
							<span class="weather_sp1_day"><?php echo $weather->forecast[$i]['day_of_week']; ?></span>
							<br style="clear:both" />
							<span class="weather_sp1_icon"><img src="<?php echo $weather->forecast[$i]['icon']; ?>" title="<?php echo $weather->forecast[$i]['condition']; ?>" alt="<?php echo $weather->forecast[$i]['condition']; ?>" />
							</span><br style="clear:both" />
							<span class="weather_sp1_temp"><?php echo modSPWeatherHelper::convert($weather->forecast[$i]['low'],$weather->unit,$tempUnit) . '&nbsp;' . $separator . '&nbsp;' . modSPWeatherHelper::convert($weather->forecast[$i]['high'],$weather->unit,$tempUnit); ?></span>
							<br style="clear:both" />
						</div>
					<?php } ?>
				<?php endfor; ?>
			</div>
		<?php } ?>
	<?php } ?>
	<div style="clear:both"></div>
</div>